* PACKAGE DEULER    !" ʬ( Euler Scheme )
*
*"  [HIS] 92/01/13 (momoko)
*"        95/08/14 (takepiro) 
*"        96/10/08 (takepiro) for topografic beta effect
***********************************************************************
      SUBROUTINE DEULER
     O             ( PSI3  , ZETA3 , T3  ,
     I               PSI2  , ZETA2 , T2  , 
     I               RAYL  , PRND  , QINT,
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2         )
*
*"      << Euler scheme ˤ꼡ƥåפʪ̤׻ >>
*"                     92/01/13 ()
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRND                 !" ץȥ
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP2 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DEULER',
     &               'EULER SCHEME TIME INTEGRATE : 95/08/14' )
      ENDIF
*
*"        < 1. ΰα٤η׻ >
*
      CALL DEULRZ
     O       ( ZETA3 , 
     I         PSI2  , ZETA2 , T2  , 
     C         RAYL  , PRND  ,
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 2. ΰβ٤η׻ >
*
      CALL DEULRT
     O       ( T3    , 
     I         PSI2  , T2  , 
     C         QINT  , 
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 3. ŬѤήؿη׻ >
*
      CALL DBNDR
     O       ( PSI3 , 
     M         ZETA3, T3  ,
     I         DX   , DZ   )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DEULRZ          !" Euler scheme ˤ뱲
     O             ( ZETA3 , 
     I               PSI2  , ZETA2 , T2  , 
     C               RAYL  , PRND  ,
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2   )
*
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !"(STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !"ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !"(1STEP)
*
      REAL PRND                      !"ץȥ
      REAL RAYL                      !"쥤꡼
*
      REAL DX                        !"Xγʻֳ
      REAL DZ                        !"Zγʻֳ
      REAL DT                        !"ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP2 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ!
      INTEGER IZ                   !"롼ץ
*
*"        < 1. ٤λѲη׻ >
*
      CALL DEULTZ
     O       ( ZETA3 , 
     I         PSI2  , ZETA2 , T2  , 
     C         RAYL  , PRND  ,
     C         DX    , DZ    , 
     W         AJAC2 , ALAP2   )
*
*"        < 2. ƥåɤα٤ͤη׻ >
*
      DO 3020 IZ = 1 , NZ
        DO 3010 IX = 1 , NX
              ZETA3( IX,IZ ) 
     &    =   ZETA2( IX,IZ ) + DT * ZETA3( IX, IZ )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
**********************************************************************
      SUBROUTINE DEULTZ          !" Euler scheme ˤ뱲٤λѲ
     O             ( TNDZ, 
     I               PSI   , ZETA  , T   , 
     C               RAYL  , PRND  ,
     C               DX    , DZ    , 
     W               AJAC  , ALAP    )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDZ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA  ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRND                      !" ץȥ
      REAL RAYL                      !" 쥤꡼
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
* [WORK]
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ!
      INTEGER IZ                   !"롼ץ
      INTEGER IUNIT
*
*  [INTERNAL SAVE]
      REAL    ETA ( NZ )        !" Ϸ¸
*     
      LOGICAL OFIRST
      DATA    OFIRST   /.TRUE./ 
      SAVE    OFIRST
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE. 
         CALL GLPGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT, * ) 'DYNAMICS WITH TOPOGRAPHIC BETA EFFECT, '
     &                      // '96/10/08'
*         
      ENDIF
*
      CALL DCETA
     O     ( ETA )
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , ZETA ,
     C         DX   , DZ    )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         ZETA ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤα٤λѲη׻ >
*
      DO 3020 IZ = 1 , NZ
        DO 3010 IX = 1 , NX
               TNDZ( IX,IZ ) 
     &     =   AJAC(IX,IZ) + PRND * ALAP(IX,IZ)
     &       - PRND*RAYL*( T(IX+1,IZ)-T(IX-1,IZ) )/(2.*DX) 
     &       + ETA(IZ)*( PSI(IX+1,IZ) - PSI(IX-1,IZ) )/(2.*DX)
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULRT                !" Euler scheme ˤ벹
     O             ( T3    , 
     I               PSI2  , T2  , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2 ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T2   ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1,0:NZ+1 ) !" 䥳ӥ
      REAL ALAP2 ( 0:NX+1,0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. ٤λѲη׻ >
*
      CALL DEULTT
     O         ( T3    , 
     I           PSI2  , T2  , 
     C           QINT  , 
     C           DX    , DZ  , 
     W           AJAC2 , ALAP2   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3020 IX = 1 , NX
        DO 3010 IZ = 1 , NZ
              T3(IX,IZ)
     &    =   T2(IX,IZ) + DT * T3( IX, IZ )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULTT        !" Euler scheme ˤ벹٤λѲ
     O             ( TNDT  , 
     I               PSI   , T    , 
     C               QINT  , 
     C               DX    , DZ   ,
     W               AJAC  , ALAP  )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDT  ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
*  [WORK]
      REAL AJAC  ( 0:NX+1,0:NZ+1 )   !" 䥳ӥ
      REAL ALAP  ( 0:NX+1,0:NZ+1 )   !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , T   ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         T    ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3020 IX = 1 , NX
        DO 3010 IZ = 1 , NZ
           TNDT(IX,IZ)
     &          =  AJAC(IX,IZ) + ALAP(IX,IZ) + QINT 
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END
